Subject: [VCARDDAV] Signed vCards

From: DataPacRat <[email-masked]>
Date: Sun, 30 Jun 2013 23:13:05 -0400

On Sat, Jun 29, 2013 at 9:27 PM, DataPacRat <[email-masked]> wrote:
> As a related thought; would it be sufficiently useful to add a tag to state
> which of the other fields in that vCard is to be preferred for sorting and
> identification purposes? For example, webfinger and webfist use an email
> address as the unique identification string; Apple seems to use UID; and I'm
> trying to work with vCards that have little more than a Twitter handle.
>
> As a minor variation of the above, perhaps instead of a single canonical ID
> string, a list in preferential order, to allow for better interoperability
> between systems requiring different sorts of ID strings.

After some initial fiddling around; something at least resembling the
above seems to be a near-necessity, for the various uses I've been
able to work with so far.

The tricky part seems to be that, when taking one authenticated vCard
and using that identity as an authentication authority itself, there
isn't any firm rule about what string to use as the identifier for
that authority. Given that some vCards have email addresses and some
don't; some have UIDs; some have Twitter handles; etc; there doesn't
seem to be any practical way to declare that one particular sort of
field /has/ to be used as a canonical ID-string. So having a
PREFERRED-ID field to have the option to declare what string is most
useful to be used as such would make implementing a full-fledged
authentication system a heckuvalot easier.

And once the field exists at all, it seems that allowing it to list
more than one field, presumably in descending order of preference,
would allow for easier interoperability between vCard systems
containing different subsets of identifying information. Eg, "The UID
is the preferred ID-string; but if your particular system doesn't
handle that, you could use the email address instead, or failing that,
the nickname."

As a practical example; the webfist protocol uses email addresses as
canonical ID strings, which, with a bit of hash function trickery,
allows for relatively easy lookups in the webfist ID database. Having
even just a short list of potential ID-strings could allow, if nothing
else, all of them to be hashed into a similar database, so that in the
future, someone seeking to authenticate that identity can lookup
whichever one of those strings they happen to have available to them.

So unless someone has a better idea, I'm definitely adding this to the
signed vCard proposal. (And since we seem to have passed the initial
inquiry stage, I'm updating the subject line accordingly.)

Thank you for your time,
--
DataPacRat
"Half of knowledge is knowing the questions." -- The Cynic's Book of Wisdom